using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace Interval.Examples.ServerControls
{
	/// <summary>
	/// Tlatko imitujc tlatko ze standardnch ovldacch prvk v ASP.NET
	/// </summary>
	[DefaultProperty("Text"),
	ToolboxData("<{0}:WebButton runat=server></{0}:WebButton>")]
	public class WebButton : System.Web.UI.WebControls.WebControl
	{

		#region Constructors
		#endregion Constructors
		
		/// <summary>
		/// Text na tlatku
		/// Hodnota vlastnosti je ukldna do ViewState
		/// </summary>
		#region properties
		[Bindable(true),
		Category("Appearance"),
		DefaultValue("")]
		public string Text
		{
			get
			{
				//Zskn hodnoty z ViewState
				string vtext = (string) ViewState["Text"];
				
				//Pokud hodnota nebyla uloena do ViewState, vra przdn etzec.
				if (vtext == null)
					return String.Empty;
					//Jinak vra hodnotu z ViewState
				else
					return vtext;
			}

			set
			{
				ViewState["Text"] = value;
			}
		}

		/// <summary>
		/// Pepeme vlastnost TagKey, protoe chceme vykreslovat tlatko
		/// </summary>
		protected override HtmlTextWriterTag TagKey
		{
			get
			{
				return 	HtmlTextWriterTag.Button;
			}
		}
		
		
		#endregion properties
		
		#region public methods
		
		
		#endregion public methods
		
		#region protected methods
		
		/// <summary>
		/// Pidme atribut onclick a name pro demonstraci monost metody AddAttributesToRender
		/// </summary>
		/// <param name="writer">Instance tdy <see cref="HtmlTextWriter"/>, kter je pouita k vykreslen prvku </param>
		protected override void AddAttributesToRender (HtmlTextWriter writer)		
		{
			//Pidn atributu onclick
			writer.AddAttribute(HtmlTextWriterAttribute.Onclick, "javascript:alert('Tlatko ' + this.id + ' stisknuto!');");
			//Pidn atributu name
			writer.AddAttribute(HtmlTextWriterAttribute.Name, this.UniqueID);
			
			//Voln metody AddAttrbutesToRender z bzov tdy, aby se vykreslily sprvn vechny atributy zddn ze tdy WebControl
			base.AddAttributesToRender(writer);

		}
		/// <summary>
		/// V metod RenderContents vypeme obsah prvku. V naem ppad pouze vlastnost <see cref="Text"/>
		/// </summary>
		/// <param name="writer"></param>
		protected override void RenderContents (HtmlTextWriter writer)
		{
			writer.Write(Text);
		}
		#endregion protected methods

		
	}
}
